//+------------------------------------------------------------------+
//|                                               ADX_Pending_EA.mq5 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include <Trade\Trade.mqh>
CTrade  trade;
input double Lot=0.1;
double risk=0.1;//sl is equal ...$
input int ADXperiod=14;

int adx;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {adx=iADX(NULL,0,ADXperiod);
//---

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {int total=0;
   bool newb=NewBar();
     for(int i=0;i<PositionsTotal();i++)
     {
      // position on our symbol
      if(Symbol()==PositionGetSymbol(i))
        {total=1;
         if(newb)Trail();//move sl everday(4.)
        }
      }
   if(total==0&&newb)//if no open positions and newbar (0.)- open
      {OpenOrder();
      }
//---

  }
//+------------------------------------------------------------------+
void OpenOrder()
{double dipl[];
 double dimi[];
 CopyBuffer(adx,1,1,1,dipl);
 CopyBuffer(adx,2,1,1,dimi);
 if(dipl[0]>dimi[0])//di+>di-(1.,2.)
   {if(iClose(NULL,0,1)<iOpen(NULL,0,1))//bear candle 3.1
     {delete_all_limit_orders();//delete old limit orders
     PlaceBuyStop();//3.1
     }
   }
 else//di+<di-(1.,2.)
   {if(iClose(NULL,0,1)>iOpen(NULL,0,1))//bull candle 3.2
     {delete_all_limit_orders();//delete old limit orders
      PlaceSellStop();//3.2
     }
   }
}

void PlaceBuyStop()
{double val=_Point*risk/(NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE),_Digits)*Lot);//+0.1 cent
   double pr=iLow(NULL,0,1);//low form previous bar
   double op_pr=iOpen(NULL,0,1);//open price


 MqlTradeRequest request={0};
   request.action=TRADE_ACTION_PENDING;         // pending order
   request.volume=Lot;                          // lot size
   request.symbol=_Symbol;
   request.price=op_pr;                          //open price
   request.sl=pr-val;                            // Stop Loss
   request.tp=0;
   request.type=ORDER_TYPE_BUY_STOP;            // ordertype
   MqlTradeResult result={0};
   int tic=OrderSend(request,result);


}
void PlaceSellStop()
{double val=_Point*risk/(NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE),_Digits)*Lot);//sl value
   double pr=iHigh(NULL,0,1);
   double op_pr=iOpen(NULL,0,1);

   MqlTradeRequest request={0};
   request.action=TRADE_ACTION_PENDING;         // pending order
   request.volume=Lot;                          // lot size
   request.symbol=_Symbol;
   request.price=op_pr;                          //open price
   request.sl=pr+val;                            // Stop Loss
   request.tp=0;
   request.type=ORDER_TYPE_SELL_STOP;            // ordertype
   MqlTradeResult result={0};
   int tic=OrderSend(request,result);
}
void delete_all_limit_orders()
{int i;
ulong lv_ticket;

    int lv_total = OrdersTotal();
    for (i = 0; i < lv_total; i++ )
      {if ((lv_ticket = OrderGetTicket(i)) > 0)
        if (OrderGetString(ORDER_SYMBOL)==_Symbol)
        {
         if((OrderGetInteger(ORDER_TYPE) == ORDER_TYPE_BUY_LIMIT || OrderGetInteger(ORDER_TYPE) == ORDER_TYPE_SELL_LIMIT ||
         OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_BUY_STOP||OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_SELL_STOP))
         {
          trade.OrderDelete(lv_ticket);
         continue;
         }
        }
      }
}


bool NewBar()//0. Know when a new bar/candle
{datetime tim[];
  CopyTime(Symbol(),0,0,1,tim);

static datetime lastbar = -1;
datetime curbar = tim[0];
if(lastbar!=curbar)
{
lastbar=curbar;
return (true);
}
else return(false);
}

//have access to the current and previous OHLC rates/prices.
double iClose(string symbol,ENUM_TIMEFRAMES timeframe,int index)

{
   if(index < 0) return(-1);
   double Arr[1];
   if(CopyClose(symbol,timeframe, index, 1, Arr)>0)
        return(Arr[0]);
   else return(-1);
}

double iOpen(string symbol,ENUM_TIMEFRAMES timeframe,int index)

{
   if(index < 0) return(-1);
   double Arr[1];
   if(CopyOpen(symbol,timeframe, index, 1, Arr)>0)
        return(Arr[0]);
   else return(-1);
}


double iHigh(string symbol,ENUM_TIMEFRAMES timeframe,int index)

{
   if(index < 0) return(-1);
   double Arr[1];
   if(CopyHigh(symbol,timeframe, index, 1, Arr)>0)
        return(Arr[0]);
   else return(-1);
}

double iLow(string symbol,ENUM_TIMEFRAMES timeframe,int index)

{
   if(index < 0) return(-1);
   double Arr[1];
   if(CopyLow(symbol,timeframe, index, 1, Arr)>0)
        return(Arr[0]);
   else return(-1);
}


void Trail()
{MqlTradeRequest request={0};
MqlTradeResult  result={0};


      request.action=TRADE_ACTION_SLTP;
          request.symbol = Symbol();
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {double sl=iLow(NULL,0,1);

            if(NormalizeDouble(sl-PositionGetDouble(POSITION_SL),_Digits)>0)
              {

               request.sl=NormalizeDouble(sl,_Digits);
               request.tp=NormalizeDouble(PositionGetDouble(POSITION_TP),_Digits);

               int t=OrderSend(request,result);
              }
           }

         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {double sl=iHigh(NULL,0,1);

            if(NormalizeDouble(PositionGetDouble(POSITION_SL)-sl,_Digits)>0)

              {
               request.sl=NormalizeDouble(sl,_Digits);
               request.tp=NormalizeDouble(PositionGetDouble(POSITION_TP),_Digits);


              int t1= OrderSend(request,result);
              }
           }
}
